#include <iostream>

#include <TGFrame.h>
#include <TGButton.h>
#include <TGLabel.h>
#include <TGComboBox.h>
#include <TGNumberEntry.h>
#include <TGClient.h>
#include <TGApplication.h>
#include <TGProgressBar.h>
#include <RQ_OBJECT.h>



class TestGUI 
{
    RQ_OBJECT( "TestGUI" )

    protected :
        TGMainFrame         *fMainFrame;


    public :
        TestGUI( const TGWindow *p, UInt_t w, UInt_t h );
        virtual ~TestGUI();

        void CloseWindow();
};


TestGUI::TestGUI( const TGWindow *p, UInt_t w, UInt_t h )
{
    fMainFrame = new TGMainFrame( p, w, h );

    //use hierarchical cleanup
    fMainFrame->SetCleanup( kDeepCleanup );

    fMainFrame->SetWindowName( "TEST" );

    fMainFrame->Connect( "CloseWindow()", "TestGUI", this, "CloseWindow()" );

    //Create label with combo
    TGGroupFrame *testGroup = new TGGroupFrame( fMainFrame, "Test", kHorizontalFrame );
    TGLabel *testLabel = new TGLabel( testGroup, "Test:" );
    TGComboBox *testCombo = new TGComboBox( testGroup );
        testCombo->AddEntry( "TEST1", 0 );
        testCombo->AddEntry( "TEST2", 1 );
        testCombo->Resize( 60, testLabel->GetDefaultHeight() );

    TGLayoutHints *groupLH = new TGLayoutHints( kLHintsTop | kLHintsExpandX, 3, 3, 3, 3 );
    TGLayoutHints *labelLH = new TGLayoutHints( kLHintsNormal, 2, 2, 2, 2 );
    TGLayoutHints *comboLH = new TGLayoutHints( kLHintsNormal, 2, 2, 2, 2 );

    testGroup->AddFrame( testLabel, labelLH );
    testGroup->AddFrame( testCombo, comboLH );
    testGroup->Resize();

    fMainFrame->AddFrame( testGroup, groupLH );

    fMainFrame->MapSubwindows();
    fMainFrame->Resize();
    fMainFrame->MapWindow();
}


TestGUI::~TestGUI()
{
    delete fMainFrame;
}


void TestGUI::CloseWindow()
{
    std::cout << "Closing window...\n";
    gApplication->Terminate();
}


void Test()
{
    new TestGUI( gClient->GetRoot(), 100, 100 );
}
